/*
    * Copyright (c) 2012, H. J. Ohlbach. All rights reserved.
    * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
    *
    * This code is free software; you can redistribute it and/or modify it
    * under the terms of the GNU General Public License version 2 only, as
    * published by the Free Software Foundation. 
    *
    * This code is distributed in the hope that it will be useful, but WITHOUT
    * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    * version 2 for more details.
    */
package Java2OWL;

import java.lang.reflect.Method;

/**
 *
 * @author ohlbach
 */
class PropertyWrapperFunctional extends PropertyWrapper {

    PropertyWrapperFunctional(Class jcl, Method getter, J2OManager manager) throws J2OException {
        super(jcl,getter,manager);}
    
     PropertyWrapperFunctional(String name) {
        super(name);}
    
    
    
    
    protected boolean determineClasses(StringBuffer errors) {
        currentPWC.rangeClass = currentPWC.getter.getReturnType();
        currentPWC.isFunctional = true;
        currentPWC.isMapper = false;
        currentPWC.types.put("setter",new Class[][]{new Class[]{currentPWC.rangeClass}});
        currentPWC.exactLength.put("setter",true);
        return true;}
    
    protected void findAccessors(J2OWLProperty annotation, StringBuffer errors, StringBuffer warnings) {
        currentPWC.setter = findAccessor("setter", annotation.setter(), true, errors, warnings);
        if(!annotation.adder().isEmpty())   warnings.append("adder ignored " + annotation.adder()+"\n");
        if(!annotation.remover().isEmpty()) warnings.append("remover ignored " + annotation.remover()+"\n");
        if(!annotation.clearer().isEmpty()) warnings.append("clearer ignored " + annotation.clearer()+"\n");
        if(!annotation.getKey().isEmpty())  warnings.append("getKey ignored " + annotation.getKey()+"\n");}
    
}
